%define rolluppatch 20110108
%define patchdate 20110108
%define version 5.9
%define release %mkrel 9
%define major 5
%define majorminor 5.9
%define utf8libname %mklibname %{name}w %{major}
%define libname %mklibname %{name} %{major}
%define develname %mklibname -d %{name}
%define utf8develname %mklibname -d %{name}w

Summary:	A CRT screen handling and optimization package
Name:		ncurses
Version:	%{version}
Release:	%{release}
License:	MIT
Group:		System/Libraries
Url:		http://www.gnu.org/software/ncurses/ncurses.html
Source0:	ftp://ftp.gnu.org/gnu/ncurses/%{name}-%{version}.tar.xz
Source4:	ncurses-resetall.sh
Source5:    	ncurses-usefull-terms
Patch1:		ncurses-5.9-20140308-patch.sh.bz2
Patch2:		ncurses-5.9-20140315-20140323.patch.xz
Patch3:		ncurses-5.9-urxvt.patch
Patch10:	ncurses-5.6-xterm-debian.patch
BuildRequires:	gpm-devel
BuildRequires:	sharutils
Conflicts:	%{name}-extraterms < 5.6-1.20070721.1
Obsoletes:	termcap
Provides:	termcap = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires: glibc >= 2.20

%description
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n %{libname}
Summary:	The development files for applications which use ncurses
Group:		System/Libraries
Requires:	ncurses = %{version}-%{release}

%description -n %{libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n %{utf8libname}
Summary:	Ncurses libraries which support UTF8
Group:		System/Libraries
Requires:	ncurses = %{version}-%{release}

%description -n %{utf8libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

This package contains ncurses libraries which support wide char (UTF8),
and is not compatible with those without.

%package extraterms
Summary:	Some exotic terminal descriptions
Group:		System/Libraries
Requires:	ncurses = %{version}-%{release}

%description extraterms
Install the ncurses-extraterms package if you use some exotic terminals.

%package -n %{develname}
Summary:	The development files for applications which use ncurses
Group:		Development/Libraries
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%mklibname -d %name 5
Obsoletes:	%{mklibname -d termcap} <= 2.0.8-16
Provides:	%{mklibname -d termcap} = %{version}-%{release}
Provides:	termcap-devel = %{version}-%{release}
%ifarch x86_64
Provides:	libtermcap-devel = %{version}-%{release}
Provides:	devel(libncurses(64bit))
Provides:	devel(libtermcap(64bit))
%else
Provides:	devel(libncurses)
Provides:	devel(libtermcap)
%endif


%description -n %{develname}
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

%package -n %{utf8develname}
Summary:	The development files for applications which use ncurses
Group:		Development/Libraries
Requires:	%{utf8libname} = %{version}-%{release}
Provides:	lib%{name}w-devel = %{version}-%{release}
Provides:	ncursesw-devel = %{version}-%{release}
Obsoletes:	%mklibname -d %{name}w 5
Conflicts:	%{_lib}ncurses-devel < 5.7-3.20091128.2

%description -n	%{utf8develname}
The libraries for developing applications that use ncurses CRT screen
handling and optimization package. Install it if you want to develop
applications which will use ncurses.

Note that the libraries included here supports wide char (UTF-8),
and is not compatible with those without. When linking programs with
these libraries, you will have to append a "w" to the library names,
i.e. -lformw, -lmenuw, -lncursesw, -lpanelw.

%prep
%setup -q

%patch1 -p1
%patch2 -p1
%patch3 -p1 -b .urxvt

# regenerating configure needs patched autoconf, so modify configure
# directly
%patch10 -p1 -b .deb

find . -name "*.orig" | xargs rm -f
# fix some permissions
chmod 755 c++/edit_cfg.sh test/listused.sh test/configure test/tracemunch

%build
export PKG_CONFIG_LIBDIR=%{_libdir}/pkgconfig

%global ncurses_options \\\
	--without-libtool \\\
	--with-shared \\\
	--with-cxx-shared \\\
	--with-normal \\\
	--without-debug \\\
	--enable-overwrite \\\
	--without-profile \\\
	--with-gpm \\\
	--enable-getcap \\\
	--enable-const \\\
	--enable-hard-tabs \\\
	--enable-hash-map \\\
	--enable-no-padding \\\
	--enable-sigwinch \\\
	--without-ada \\\
	--enable-xmc-glitch \\\
	--enable-colorfgbg \\\
	--enable-pc-files \\\
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \\\
	--with-termlib=tinfo \\\
	--with-chtype=long \\\
	--with-ospeed=unsigned \\\
	--with-xterm-kbs=DEL

mkdir -p ncurses-normal
pushd ncurses-normal
CONFIGURE_TOP=.. 
%configure2_5x \
	%{ncurses_options} \
	--includedir=%{_includedir}/ncurses \
	--disable-widec \
	--with-ticlib
	
%make -j1
popd

mkdir -p ncurses-utf8
pushd ncurses-utf8
CONFIGURE_TOP=.. 
%configure2_5x \
	%{ncurses_options} \
	--includedir=%{_includedir}/ncursesw \
	--enable-widec \
	--without-progs
	
%make -j1
popd

%install
rm -rf %{buildroot}

pushd ncurses-utf8
%{makeinstall_std}
popd

pushd ncurses-normal
%{makeinstall_std}
popd

ln -sf ../l/linux %{buildroot}%{_datadir}/terminfo/c/console
ln -sf ncurses/curses.h %{buildroot}/usr/include/ncurses.h
for I in curses unctrl eti form menu panel term; do
	ln -sf ncurses/$I.h %{buildroot}/usr/include/$I.h
done

# the resetall script
install -m 755 %{SOURCE4} %{buildroot}%{_bindir}/resetall
# we don't want this in doc
rm -f c++/demo

mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses.so.%{major} %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses.so.%{majorminor} %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses.so.%{majorminor} %{buildroot}%{_libdir}/libncurses.so.%{majorminor}
ln -s /%{_lib}/libncurses.so.%{major} %{buildroot}%{_libdir}/libncurses.so.%{major}

mv %{buildroot}%{_libdir}/libncursesw.so.%{major} %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncursesw.so.%{majorminor} %{buildroot}/%{_lib}
ln -s /%{_lib}/libncursesw.so.%{majorminor} %{buildroot}%{_libdir}/libncursesw.so.%{majorminor}
ln -s /%{_lib}/libncursesw.so.%{major} %{buildroot}%{_libdir}/libncursesw.so.%{major}

mv %{buildroot}%{_libdir}/libncurses++.so.%{major} %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses++.so.%{majorminor} %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses++.so.%{majorminor} %{buildroot}%{_libdir}/libncurses++.so.%{majorminor}
ln -s /%{_lib}/libncurses++.so.%{major} %{buildroot}%{_libdir}/libncurses++.so.%{major}

mv %{buildroot}%{_libdir}/libtinfo.so.%{major} %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libtinfo.so.%{majorminor} %{buildroot}/%{_lib}
ln -s /%{_lib}/libtinfo.so.%{majorminor} %{buildroot}%{_libdir}/libtinfo.so.%{majorminor}
ln -s /%{_lib}/libtinfo.so.%{major} %{buildroot}%{_libdir}/libtinfo.so.%{major}


#
# FIXME
# OK do not time to debbug it now
#
cp %{buildroot}%{_datadir}/terminfo/x/xterm %{buildroot}%{_datadir}/terminfo/x/xterm2
cp %{buildroot}%{_datadir}/terminfo/x/xterm-new %{buildroot}%{_datadir}/terminfo/x/xterm


#
# remove unneeded/unwanted files
# have to be done before find commands below
#
rm -f %{buildroot}%{_libdir}/terminfo

# fwang: avoid conflict with kon package
rm -f %{buildroot}%{_datadir}/terminfo/k/kon

sed -i -e 's,Requires.private,Requires,g' %{buildroot}%{_libdir}/pkgconfig/ncurses*.pc

#
# FIXME
#
(cd %{buildroot} ; find usr/share/terminfo      -type d | perl -pe 's||%%dir /|') > %{name}.list
(cd %{buildroot} ; find usr/share/terminfo -not -type d | perl -pe 's||/|')       > %{name}-extraterms.list
perl -pe 's||%{_datadir}/terminfo/|' %{SOURCE5} >> %{name}.list

perl -ni -e 'BEGIN { open F, "%{name}.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' %{name}-extraterms.list

find %{buildroot}/%{_libdir} -name 'lib*.a' -not -type d -not -name "*_g.a" -not -name "*_p.a" -not -name "*w.a" | sed -e "s#^%{buildroot}##" > %{libname}-devel.list

%multiarch_includes %{buildroot}%{_includedir}/ncurses/curses.h

%multiarch_includes %{buildroot}%{_includedir}/ncursesw/curses.h


rm -f %{buildroot}%{_libdir}/libcurses{,w}.so
echo "INPUT(-lncurses)" > %{buildroot}%{_libdir}/libcurses.so
echo "INPUT(-lncursesw)" > %{buildroot}%{_libdir}/libcursesw.so
echo "INPUT(-ltinfo)" > %{buildroot}%{_libdir}/libtermcap.so


%post -n %{libname}
/sbin/ldconfig

%postun -n %{libname}
/sbin/ldconfig

%post -n %{utf8libname}
/sbin/ldconfig

%postun -n %{utf8libname}
/sbin/ldconfig


%clean
rm -rf %{buildroot}

%files -f %{name}.list
%defattr(-,root,root)
%doc README ANNOUNCE
%{_datadir}/tabset
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%files -n %{libname}
%defattr(-,root,root)
%attr(755,root,root) /%{_lib}/libncurses.so.*
%attr(755,root,root) /%{_lib}/libncurses++.so.*
%attr(755,root,root) /%{_lib}/libtinfo.so.*
%attr(755,root,root) %{_libdir}/libform.so.*
%attr(755,root,root) %{_libdir}/libmenu.so.*
%attr(755,root,root) %{_libdir}/libncurses.so.*
%attr(755,root,root) %{_libdir}/libpanel.so.*
%attr(755,root,root) %{_libdir}/libncurses++.so.*
%attr(755,root,root) %{_libdir}/libtic.so.*
%attr(755,root,root) %{_libdir}/libtinfo.so.*


%files -n %{utf8libname}
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/lib*w.so.*
%attr(755,root,root) /%{_lib}/libncursesw.so.*

%files extraterms -f %{name}-extraterms.list
%defattr(-,root,root)
%doc README

%files -n %{develname}
%defattr(-,root,root)
%doc doc c++ test
%{_libdir}/libcurses.a
%{_libdir}/libcurses.so
%{_libdir}/libform.a
%{_libdir}/libform.so
%{_libdir}/libmenu.a
%{_libdir}/libmenu.so
%{_libdir}/libncurses++.a
%{_libdir}/libncurses++.so
%{_libdir}/libncurses.a
%{_libdir}/libncurses.so
%{_libdir}/libpanel.a
%{_libdir}/libpanel.so
%{_libdir}/libtic.a
%{_libdir}/libtic.so
%{_libdir}/libtinfo.a
%{_libdir}/libtinfo.so
%{_libdir}/libtermcap.so
%{_libdir}/pkgconfig/form.pc
%{_libdir}/pkgconfig/menu.pc
%{_libdir}/pkgconfig/ncurses++.pc
%{_libdir}/pkgconfig/ncurses.pc
%{_libdir}/pkgconfig/panel.pc
%{_libdir}/pkgconfig/tic.pc
%{_libdir}/pkgconfig/tinfo.pc
%{_includedir}/ncurses
%{multiarch_includedir}/ncurses
%{_includedir}/*.h
%{_mandir}/man3/*

%files -n %{utf8develname}
%defattr(-,root,root)
%{_includedir}/ncursesw
%{_libdir}/pkgconfig/*w.pc
%{multiarch_includedir}/ncursesw
%{_libdir}/lib*w.so
%{_libdir}/lib*w.a

%changelog
* Tue Feb 24 2015 bb <bb> 5.9-9pclos2015
- rebuild new glibc

* Wed Oct 15 2014 bb <bb> 5.9-8pclos2014
- fix package for libtinfo

* Wed Oct 15 2014 bb <bb> 5.9-7pclos2014
- adjust build

* Thu Oct 08 2014 bb <bb> 5.9-6pclos2014
- adjust build options

* Wed Oct 07 2014 bb <bb> 5.9-5pclos2014
- apply fedora patches

* Wed Oct 01 2014 bb <bb> 5.9-4pclos2014
- fix for bash

* Sat Sep 26 2014 bb <bb> 5.9-3pclos2014
- rebuild against current libs

